Differences between revisions 14 and 23 (spanning 9 versions)
Revision 14 as of 2009-12-10 00:51:36
Size: 5800
Editor: c122-108-164-114
Comment:
Revision 23 as of 2010-02-28 00:29:14
Size: 7382
Editor: 158
Comment: If you use "set -o nounset" (or "set -u"), the "manual loop" should be changed, since it finally can "work" with the value of an unset variable.
Deletions are marked like this. Additions are marked like this.
Line 3: Line 3:
Well, that depends a great deal on what you want to do with them. Here's a general template that might help for the simple cases: Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.

=== Manual loop ===
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this turns out to be the simplest and most direct approach, since very few scripts need complicated option processing.

Here's an example that will handle a combination of short (`-h`) and long (`--help`) options.
Line 14: Line 19:
            printf "%s\n" "-f requires an argument"             echo "-f requires an argument" 1>&2
Line 18: Line 23:
      -*) echo "invalid option: $1"; show_help; exit 1;;       -*) echo "invalid option: $1" 1>&2; show_help; exit 1;;
Line 23: Line 28:

Many Bash programmers write at the beginning of their scripts:
{{{
    #!/bin/bash
    set -o nounset
}}}
to avoid some errors, this is very advisable. This way Bash stops if it's forced to work with the value of an unset variable. If you use "set -o nounset", in the prior "manual loop" you can write:
{{{
   # // If $1 is unset for the next iteration
   if ! test "${1+defined}"; then
      break
   fi
}}}
between
{{{
  esac
}}}
and
{{{
  done
}}}
Line 34: Line 60:
            printf "%s\n" "-f requires an argument"             echo "-f requires an argument" 1>&2
Line 38: Line 64:
      -*) echo "invalid option: $1"; show_help; exit 1;;       -*) echo "invalid option: $1" 1>&2; show_help; exit 1;;
Line 44: Line 70:
For more complex/generalized cases, or if you want things like "-xvf" to be handled as three separate flags, or if you want to handle [[http://www.gnu.org/software/libtool/manual/libc/Argument-Syntax.html|GNU-style long options]], you need a different approach. What this example ''does not'' handle are:
 * You want things like `-xvf` to be handled as three separate flags (equivalent to `-x -v -f`).
 * You want to parse arguments out of `--file=bar`.

It's certainly possible to do those things by changing the code, but at least in the first case, there's another approach that handles that automatically.

=== getopts ===
Line 48: Line 80:
The POSIX shell (and others) offer `getopts` which is safe to use. Here is a simplistic `getopts` example: The POSIX shell (and others) offer `getopts` which is safe to use instead. Here is a simplistic `getopts` example:
Line 53: Line 85:
while getopts "abcf:g:h:" opt; do while getopts "h?vf:" opt; do
Line 55: Line 87:
    a) echo "You said a";;
    b) echo "You said b";;
    c) echo "You said c";;
    f) echo "You said f, with argument $OPTARG";;
    g) echo "You said g, with argument $OPTARG";;
    h) echo "You said h, with argument $OPTARG";;
    h|\?) show_help; exit 0;;
    v) verbose=1;;
    f) output_file=$OPTARG;;
Line 65: Line 94:
echo "Left overs: $@" if [ "$1" = -- ]; then shift; fi
echo "verbose=$verbose, output_file='$output_file', Leftovers: $@"
Line 68: Line 98:
There is still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. The disadvantage of `getopts` is that it can only handle short options (`-h`), not long options. But it handles `-vf filename` in the expected Unix way, automatically. So, if one wishes to sacrifice `--help` to get `-vf filename`, then `getops` is a good candidate.

There is a [[http://bash-hackers.org/wiki/doku.php/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`, which might be informative.

There is also
still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later.

=== Silly repeated brute-force scanning ===
Line 79: Line 115:
      --) return 1; # by convention, -- is end of options       --) return 1;; # by convention, -- is end of options
Line 88: Line 124:
Line 92: Line 129:
Line 96: Line 134:
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. But it does offer a consolidation of the option-handling code into a single place (or two places if you count the help message).
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables.

It also spreads the options throughout the program. The literal option `--quick` may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance.

=== Complex nonstandard add-on utilities ===
Line 106: Line 149:
source /usr/bin/process-getopt source process-getopt
Line 137: Line 180:
It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an old-fashioned one (ie one that does not return 4 for {{{getopt --test}}} it only processes short options. It does not use the bash-builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for {{{getopt --test}}}) it only processes short options. It does not use the bash builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]]

----
CategoryShell

How can I handle command-line arguments (options) to my script easily?

Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.

Manual loop

This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this turns out to be the simplest and most direct approach, since very few scripts need complicated option processing.

Here's an example that will handle a combination of short (-h) and long (--help) options.

# Bash
while [[ $1 == -* ]]; do
    case "$1" in
      -h|--help|-\?) show_help; exit 0;;
      -v|--verbose) verbose=1; shift;;
      -f) if (($# > 1)); then
            output_file=$2; shift 2
          else 
            echo "-f requires an argument" 1>&2
            exit 1
          fi ;;
      --) shift; break;;
      -*) echo "invalid option: $1" 1>&2; show_help; exit 1;;
    esac
done

Now all of the remaining arguments are the filenames which followed the optional switches. You can process those with for i or "$@".

Many Bash programmers write at the beginning of their scripts:

    #!/bin/bash
    set -o nounset

to avoid some errors, this is very advisable. This way Bash stops if it's forced to work with the value of an unset variable. If you use "set -o nounset", in the prior "manual loop" you can write:

   # // If $1 is unset for the next iteration
   if ! test "${1+defined}"; then
      break
   fi

between

  esac

and

  done

A POSIX version of that same code:

# POSIX
while true; do
    case "$1" in
      -h|--help|-\?) show_help; exit 0;;
      -v|--verbose) verbose=1; shift;;
      -f) if [ $# -gt 1 ]; then
            output_file=$2; shift 2
          else 
            echo "-f requires an argument" 1>&2
            exit 1
          fi ;;
      --) shift; break;;
      -*) echo "invalid option: $1" 1>&2; show_help; exit 1;;
      *)  break;;
    esac
done

What this example does not handle are:

  • You want things like -xvf to be handled as three separate flags (equivalent to -x -v -f).

  • You want to parse arguments out of --file=bar.

It's certainly possible to do those things by changing the code, but at least in the first case, there's another approach that handles that automatically.

getopts

Never use getopt(1). getopt cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed.

The POSIX shell (and others) offer getopts which is safe to use instead. Here is a simplistic getopts example:

# POSIX
x=1         # Avoids an error if we get no options at all.
while getopts "h?vf:" opt; do
  case "$opt" in
    h|\?) show_help; exit 0;;
    v) verbose=1;;
    f) output_file=$OPTARG;;
  esac
  x=$OPTIND
done
shift $(($x-1))
if [ "$1" = -- ]; then shift; fi
echo "verbose=$verbose, output_file='$output_file', Leftovers: $@"

The disadvantage of getopts is that it can only handle short options (-h), not long options. But it handles -vf filename in the expected Unix way, automatically. So, if one wishes to sacrifice --help to get -vf filename, then getops is a good candidate.

There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts, which might be informative.

There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later.

Silly repeated brute-force scanning

Another approach is to check options with if statements "on demand". A function like this one may be useful:

# Bash
HaveOpt() {
  local needle=$1
  shift
  while [[ $1 == -* ]]; do
    case "$1" in
      --) return 1;; # by convention, -- is end of options
      $needle) return 0;;
    esac
    shift
  done
  return 1
}
if HaveOpt --quick "$@"; then echo "Option quick is set"; fi

and it will work if script is run as:

  • YES: ./script --quick
  • YES: ./script -other --quick

but will stop on first argument with no "-" in front (or on --):

  • NO: ./script -bar foo --quick
  • NO: ./script -bar -- --quick

Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables.

It also spreads the options throughout the program. The literal option --quick may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance.

Complex nonstandard add-on utilities

bhepple suggests the use of process-getopt (GPL licensed) and offers this example code:

PROG=$(basename $0)
VERSION='1.2'
USAGE="A tiny example using process-getopt(1)"

# call process-getopt functions to define some options:
source process-getopt

SLOT=""
SLOT_func()   { [ "${1:-""}" ] && SLOT="yes"; }      # callback for SLOT option
add_opt SLOT "boolean option" s "" slot

TOKEN=""
TOKEN_func()  { [ "${1:-""}" ] && TOKEN="$2"; }      # callback for TOKEN option
add_opt TOKEN "this option takes a value" t n token number

add_std_opts     # define the standard options --help etc:

TEMP=$(call_getopt "$@") || exit 1
eval set -- "$TEMP" # just as with getopt(1)

# remove the options from the command line
process_opts "$@" || shift "$?"

echo "SLOT=$SLOT"
echo "TOKEN=$TOKEN"
echo "args=$@"

Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.

  • Actually, what the author forgot to say was that it's actually using getopts semantics, rather than getopt. I ran this test:

     wooledg@wooledg:~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'"
     wooledg@wooledg:~/process-getopt-1.6$ call_getopt "$@"
      -- 'rm -rf /' 'foo;bar' ''\'''
  • It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the eval not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat

It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for getopt --test) it only processes short options. It does not use the bash builtin getopts(1) command. -bhepple


CategoryShell

BashFAQ/035 (last edited 2024-02-26 07:51:38 by larryv)